// Copyright (c) 2017 Douglas Miller <durgadas311@gmail.com>
import java.awt.*;
import javax.swing.*;

public class CardSelector {
	ButtonGroup memBg;
	JRadioButton noMem;
	JRadioButton m312;
	JRadioButton m318;
	JOptionPane mem;
	JPanel memPan;

	ButtonGroup devBg;
	JRadioButton noDev;
	JRadioButton m316;
	JRadioButton m320;
	JRadioButton m422;
	JRadioButton z11;
	JRadioButton z17;
	JRadioButton z37;
	JRadioButton usb;
	JOptionPane dev;
	JPanel devPan;

	public CardSelector() {
		memBg = new ButtonGroup();
		noMem = new JRadioButton("None (16-48K by JJ501/JJ502)", true);
		noMem.setActionCommand("none");
		memBg.add(noMem);
		m312 = new JRadioButton("MMS/Heath/Zenith 16K Add-on (64K)");
		m312.setActionCommand("MMS77312");
		memBg.add(m312);
		m318 = new JRadioButton("MMS 128K Add-on (176K)");
		m318.setActionCommand("MMS77318");
		memBg.add(m318);
		memPan = new JPanel();
		memPan.setLayout(new BoxLayout(memPan, BoxLayout.Y_AXIS));
		memPan.add(new JLabel("Select Memory Add-on"));
		memPan.add(noMem);
		memPan.add(m312);
		memPan.add(m318);
		mem = new JOptionPane(memPan, JOptionPane.PLAIN_MESSAGE,
			JOptionPane.OK_CANCEL_OPTION);

		devBg = new ButtonGroup();
		noDev = new JRadioButton("None");
		noDev.setActionCommand("none");
		devBg.add(noDev);
		m316 = new JRadioButton("MMS77316");
		m316.setActionCommand("MMS77316");
		devBg.add(m316);
		m320 = new JRadioButton("MMS77320");
		m320.setActionCommand("MMS77320");
		devBg.add(m320);
		m422 = new JRadioButton("MMS77422");
		m422.setActionCommand("MMS77422");
		devBg.add(m422);
		z11 = new JRadioButton("Z-89-11");
		z11.setActionCommand("Z-89-11");
		devBg.add(z11);
		z17 = new JRadioButton("Z17");
		z17.setActionCommand("Z17");
		devBg.add(z17);
		z37 = new JRadioButton("Z37");
		z37.setActionCommand("Z37");
		devBg.add(z37);
		usb = new JRadioButton("H89USB");
		usb.setActionCommand("H89USB");
		devBg.add(usb);
		devPan = new JPanel();
		devPan.setLayout(new BoxLayout(devPan, BoxLayout.Y_AXIS));
		devPan.add(new JLabel("Select I/O Device Card"));
		devPan.add(noDev);
		devPan.add(m316);
		devPan.add(m320);
		devPan.add(m422);
		devPan.add(z11);
		devPan.add(z17);
		devPan.add(z37);
		devPan.add(usb);
		dev = new JOptionPane(devPan, JOptionPane.PLAIN_MESSAGE,
			JOptionPane.OK_CANCEL_OPTION);
	}

	public boolean doMemDialog(Component top, String ctx) {
		Dialog dlg = mem.createDialog(top, "Select Memory for Slot " + ctx);
		dlg.setVisible(true);
		Object res = mem.getValue();
		if (res == null || res.equals(JOptionPane.CANCEL_OPTION)) {
			return false;
		}
		return true;
	}

	public void setMemSelection(String mem) {
		if (mem.equals(m312.getActionCommand())) {
			m312.setSelected(true);
		} else if (mem.equals(m318.getActionCommand())) {
			m318.setSelected(true);
		} else {
			noMem.setSelected(true);
		}
	}

	public String getMemSelection() {
		ButtonModel bm = memBg.getSelection();
		return bm.getActionCommand();
	}

	public boolean doDevDialog(Component top, String ctx) {
		Dialog dlg = dev.createDialog(top, "Select I/O Card for Slot " + ctx);
		dlg.setVisible(true);
		Object res = dev.getValue();
		if (res == null || res.equals(JOptionPane.CANCEL_OPTION)) {
			return false;
		}
		return true;
	}

	public void setDevSelection(String dev) {
		if (dev.equals(m316.getActionCommand())) {
			m316.setSelected(true);
		} else if (dev.equals(m320.getActionCommand())) {
			m320.setSelected(true);
		} else if (dev.equals(m422.getActionCommand())) {
			m422.setSelected(true);
		} else if (dev.equals(z11.getActionCommand())) {
			z11.setSelected(true);
		} else if (dev.equals(z17.getActionCommand())) {
			z17.setSelected(true);
		} else if (dev.equals(z37.getActionCommand())) {
			z37.setSelected(true);
		} else if (dev.equals(usb.getActionCommand())) {
			usb.setSelected(true);
		} else {
			noDev.setSelected(true);
		}
	}

	public String getDevSelection() {
		ButtonModel bm = devBg.getSelection();
		return bm.getActionCommand();
	}
}
