// Copyright (c) 2017 Douglas Miller <durgadas311@gmail.com>
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class CardSlot extends JButton {
	public static int MEMORY = 1;
	public static int IO = 2;

	static private ImageIcon slot = new ImageIcon(CardSlot.class.getResource("icons/slot.png"));
	static private ImageIcon card = new ImageIcon(CardSlot.class.getResource("icons/card.png"));
	private AddOnCard value = null;
	private String label = null;
	private String prop = null;
	private int type = 0;

	public CardSlot(String label, int type, String prop) {
		super();
		this.label = label;
		this.type = type;
		this.prop = prop;
		setBorder(null);
		setOpaque(false);
		setContentAreaFilled(false);
		setBorderPainted(false);
		setValue(null);
	}

	public void setValue(AddOnCard val) {
		value = val;
		if (value == null) {
			setIcon(slot);
			setToolTipText(label);
		} else {
			setIcon(card);
			setToolTipText(val.getCardName());
		}
		repaint();
	}

	public AddOnCard getValue() {
		return value;
	}

	public int getType() {
		return type;
	}

	public String getName() {
		return label;
	}

	public String getPropertyName() {
		return prop;
	}
}
