// Copyright (c) 2017 Douglas Miller <durgadas311@gmail.com>
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import java.util.Properties;

public class ConfigH89 implements ChangeListener, ActionListener {

	private static ConfigH89 thus;

	private JFrame frame;
	private Dipsw8 sw501;
	private Jumper jj501;
	private Jumper jj502;
	private CardSlot[] slots = new CardSlot[6];
	private CardSelector selector;
	private Z19 z19;
	private EPROM u518;
	private EPROM u520;
	private JButton p513;
	private JMenuItem save;

	private Properties props;
	private File curFile = null;
	private File curDir;
	private boolean changed = false;
	static final String title = "Configure Virtual H89";

	private ConfigH89(String[] args) {
		curDir = new File(System.getProperty("user.dir"));
		selector = new CardSelector();
		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints gc = new GridBagConstraints();

		frame = new JFrame(title);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setBackground(AddOnCard.PCB);
		frame.setLayout(gb);

		////////////////////////////////////////////////
		// Setup menus
		//
		JMenuBar mb = new JMenuBar();
		JMenu mu;
		JMenuItem mi;
		mu = new JMenu("File");
		mi = new JMenuItem("New", KeyEvent.VK_N);
		mi.addActionListener(this);
		mu.add(mi);
		mi = new JMenuItem("Open", KeyEvent.VK_O);
		mi.addActionListener(this);
		mu.add(mi);
		mi = new JMenuItem("Save", KeyEvent.VK_S);
		save = mi;
		mi.addActionListener(this);
		mu.add(mi);
		mi = new JMenuItem("Save As", KeyEvent.VK_A);
		mi.addActionListener(this);
		mu.add(mi);
		mi = new JMenuItem("Quit", KeyEvent.VK_Q);
		mi.addActionListener(this);
		mu.add(mi);
		mb.add(mu);
		mu = new JMenu("Config");
		mi = new JMenuItem("V89", KeyEvent.VK_V);
		mi.addActionListener(this);
		mu.add(mi);
		mi = new JMenuItem("CPNETDevice", KeyEvent.VK_C);
		mi.addActionListener(this);
		mu.add(mi);
		mb.add(mu);
		frame.setJMenuBar(mb);

		////////////////////////////////////////////////
		// Layout H89 Main PCB...
		//
		gc.fill = GridBagConstraints.NONE;
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0;
		gc.weighty = 0;
		gc.gridwidth = 1;
		gc.gridheight = 1;
		gc.anchor = GridBagConstraints.CENTER;
		JPanel pn;

		gc.gridwidth = 15;
		pn = new JPanel();
		pn.setPreferredSize(new Dimension(200,10));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);
		++gc.gridy;

		gc.gridwidth = 1;
		gc.gridheight = 6;
		pn = new JPanel();
		pn.setPreferredSize(new Dimension(20,860));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);
		++gc.gridx;

		slots[0] = new CardSlot("P501", CardSlot.MEMORY, "slot_p501");
		slots[0].addActionListener(this);
		gb.setConstraints(slots[0], gc);
		frame.add(slots[0]);
		++gc.gridx;

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(20,860));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);
		++gc.gridx;

		slots[1] = new CardSlot("P502", CardSlot.MEMORY, "slot_p502");
		slots[1].addActionListener(this);
		gb.setConstraints(slots[1], gc);
		frame.add(slots[1]);
		++gc.gridx;

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(20,860));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);
		++gc.gridx;

		slots[2] = new CardSlot("P503", CardSlot.MEMORY, "slot_p503");
		slots[2].addActionListener(this);
		gb.setConstraints(slots[2], gc);
		frame.add(slots[2]);
		++gc.gridx;

		gc.gridheight = 1;
		gc.gridwidth = 3;
		pn = new JPanel();
		pn.setPreferredSize(new Dimension(500,500));
		pn.setOpaque(false);
		pn.add(new JLabel("Heath/Zenith 89/90 Series Computer"));
		gb.setConstraints(pn, gc);
		frame.add(pn);
		gc.gridx += 3;

		gc.gridwidth = 1;
		gc.gridheight = 6;
		slots[3] = new CardSlot("P504", CardSlot.IO, "slot_p504");
		slots[3].addActionListener(this);
		gb.setConstraints(slots[3], gc);
		frame.add(slots[3]);
		++gc.gridx;

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(20,860));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);
		++gc.gridx;

		gc.gridwidth = 1;
		gc.gridheight = 6;
		slots[4] = new CardSlot("P505", CardSlot.IO, "slot_p505");
		slots[4].addActionListener(this);
		gb.setConstraints(slots[4], gc);
		frame.add(slots[4]);
		++gc.gridx;

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(20,860));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);
		++gc.gridx;

		gc.gridwidth = 1;
		gc.gridheight = 6;
		slots[5] = new CardSlot("P506", CardSlot.IO, "slot_p506");
		slots[5].addActionListener(this);
		gb.setConstraints(slots[5], gc);
		frame.add(slots[5]);
		++gc.gridx;

		gc.gridheight = 4;
		pn = new JPanel();
		pn.setPreferredSize(new Dimension(20,300));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);

		gc.gridheight = 1;
		++gc.gridy;

		Jumper3Horiz jp;

		gc.gridx = 6;
		EPROM ep = new EPROM("U518", "System ROM", "monitor_rom");
		ep.addActionListener(this);
		u518 = ep;
		gb.setConstraints(ep, gc);
		frame.add(ep);
		++gc.gridx;

		gc.gridwidth = 2;
		gc.gridheight = 1;
		pn = new JPanel();
		pn.setPreferredSize(new Dimension(150,50));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);

		gc.gridheight = 2;
		gc.gridwidth = 1;
		gc.gridx = 6;
		++gc.gridy;

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(50,50));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);
		++gc.gridx;

		gc.gridheight = 1;
		jj502 = jp = new Jumper3Horiz("JJ502", this);
		pn = new JPanel();
		pn.setOpaque(false);
		pn.add(new JLabel("JJ502"));
		pn.add(jp);
		gb.setConstraints(pn, gc);
		frame.add(pn);
		++gc.gridx;

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(50,50));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);

		gc.gridx = 7;
		++gc.gridy;

		jj501 = jp = new Jumper3Horiz("JJ501", this);
		pn = new JPanel();
		pn.setOpaque(false);
		pn.add(new JLabel("JJ501"));
		pn.add(jp);
		gb.setConstraints(pn, gc);
		frame.add(pn);

		gc.gridx = 6;
		++gc.gridy;

		ep = new EPROM("U520", "Floppy ROM", "floppy_rom");
		ep.addActionListener(this);
		u520 = ep;
		gb.setConstraints(ep, gc);
		frame.add(ep);
		++gc.gridx;

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(300,50));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);
		++gc.gridx;

		gc.gridheight = 2;
		--gc.gridy;
		sw501 = new Dipsw270("SW501", this);
		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(new JLabel("SW501"));
		pn.add(sw501);
		gb.setConstraints(pn, gc);
		frame.add(pn);
		gc.gridx += 6;
		++gc.gridy;

		ImageIcon le = new ImageIcon(ConfigH89.class.getResource("icons/jp15_ra_ri_cable.png"));
		p513 = new JButton();
		p513.addActionListener(this);
		p513.setBorder(null);
		p513.setBackground(AddOnCard.PCB);
		p513.setIcon(le);
		p513.setToolTipText("Z19");
		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(new JLabel("P513"));
		pn.add(p513);
		gb.setConstraints(pn, gc);
		frame.add(pn);

		gc.gridheight = 1;

		gc.gridx = 6;
		++gc.gridy;

		gc.gridwidth = 3;
		pn = new JPanel();
		pn.setPreferredSize(new Dimension(50,50));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);

		gc.gridheight = 1;
		gc.gridwidth = 1;
		++gc.gridy;

		gc.gridx = 0;
		gc.gridwidth = 15;
		pn = new JPanel();
		pn.setPreferredSize(new Dimension(200,10));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		frame.add(pn);
		++gc.gridy;

		z19 = new Z19(this);

		Properties p = new Properties();
		if (args.length > 0) {
			curFile = new File(args[0]);
			try {
				FileInputStream f = new FileInputStream(curFile);
				p.load(f);
			} catch(Exception ee) {
				System.err.format("No config file: %s\n", args[0]);
				System.exit(1);
			}
		}
		setProperties(p);
		changed = false;

		frame.pack();
		frame.setVisible(true);
	}

	private AddOnCard getCard(String dev) {
		AddOnCard c = null;
		if (dev.equals("MMS77320")) {
			c = new MMS77320(this);
		} else if (dev.equals("MMS77316")) {
			c = new MMS77316(this);
		} else if (dev.matches("[HZ]17") || dev.matches("H88-1")) {
			c = new Z17(this);
		} else if (dev.matches("[HZ]37") || dev.matches("[HZ]89-37")) {
			c = new Z37(this);
		} else if (dev.equals("MMS77422")) {
			c = new MMS77422(this);
		} else if (dev.equals("H-88-3") || dev.equals("HA-88-3") || dev.equals("Z-89-11")) {
			c = new Z_89_11(this);
		} else if (!dev.equals("none")) {
			// TODO: create real objects...
			c = new GenericCard(dev);
		}
		return c;
	}

	private void setProperties(Properties p) {
		if (curFile == null) {
			save.setEnabled(false);
			frame.setTitle(title + " - No File");
		} else {
			save.setEnabled(true);
			frame.setTitle(title + " - " + curFile.getName());
		}
		props = p;
		String s;
		DiskDialog.setProperties(props);
		z19.setProperties(props);
		for (CardSlot cs : slots) {
			s = props.getProperty(cs.getPropertyName());
			if (s != null) {
				AddOnCard c = getCard(s);
				cs.setValue(c);
				c.setProperties(props);
			} else {
				cs.setValue(null);
			}
		}
		s = props.getProperty("sw501");
		if (s != null) {
			int v = Integer.valueOf(s, 2) & 0xff;
			sw501.setValue(v);
		} else {
			sw501.setValue(0);
		}
		s = props.getProperty("jj501");
		if (s != null) {
			int v = Integer.valueOf(s, 2) & 1;
			jj501.setValue(v);
		} else {
			jj501.setValue(0);
		}
		s = props.getProperty("jj502");
		if (s != null) {
			int v = Integer.valueOf(s, 2) & 1;
			jj502.setValue(v);
		} else {
			jj502.setValue(0);
		}
		s = props.getProperty("monitor_rom");
		u518.setValue(s == null ? null : new File(s));
		s = props.getProperty("floppy_rom");
		u520.setValue(s == null ? null : new File(s));
	}

	private void updateProperties() {
		props.setProperty("sw501", sw501.getProp());
		props.setProperty("jj501", Integer.toBinaryString(jj501.getValue()));
		props.setProperty("jj502", Integer.toBinaryString(jj502.getValue()));
		z19.updateProperties(props);

		for (CardSlot cs : slots) {
			AddOnCard c = cs.getValue();
			if (c != null) {
				props.setProperty(cs.getPropertyName(), c.getCardName());
				c.updateProperties(props);
			}
		}
		File f = u518.getValue();
		if (f != null) {
			props.setProperty(u518.getPropertyName(), f.getAbsolutePath());
		} else {
			props.remove(u518.getPropertyName());
		}
		f = u520.getValue();
		if (f != null) {
			props.setProperty(u520.getPropertyName(), f.getAbsolutePath());
		} else {
			props.remove(u520.getPropertyName());
		}
	}

	private boolean confirmChanges(String op) {
		if (changed) {
			int res = confirm(frame, op, "Changes have not been saved. " +
					"Discard changes?");
			if (res == JOptionPane.YES_OPTION) {
				return true;
			}
			return false;
		}
		return true;
	}

	private void saveFile(boolean pick) {
		updateProperties();
		if (pick || curFile == null) {
			File f = pickFile(frame, curFile == null ? curDir : curFile,
						"Save File");
			if (f == null) {
				return;
			}
			curFile = f;
			frame.setTitle(title + " - " + curFile.getName());
		}
		try {
			FileOutputStream f = new FileOutputStream(curFile);
			props.store(f, "Updated by ConfigH89");
			changed = false;
		} catch (Exception ee) {
			error(frame, "Save File", ee.getMessage());
		}
	}

	private void setupFile(File fi) {
		Properties p = new Properties();
		// TEMP during bring-up...
		if (fi != null) {
			try {
				FileInputStream f = new FileInputStream(fi);
				p.load(f);
				curFile = fi;
			} catch (Exception ee) {
				error(frame, "Open File", ee.getMessage());
			}
		}
		setProperties(p);
		changed = false;
	}

	private File pickFile(Component top, File cur, String purpose) {
		File file = cur;
		SuffFileChooser ch = new SuffFileChooser(purpose,
			null, null, null, null, cur == null ? curDir : cur, 0);
		int rv = ch.showDialog(top);
		if (rv == JFileChooser.APPROVE_OPTION) {
			file = ch.getSelectedFile();
		}
		// still could be null?
		return file;
	}

	private void removeCard(CardSlot cs) {
		AddOnCard cd = cs.getValue();
		if (cd == null) {
			return;
		}
		cs.setValue(null);
		cd.removeProperties(props);
		props.remove(cs.getPropertyName());
		changed = true;
	}

	private void epromPlug(EPROM ep) {
		File f = pickFile(frame, ep.getValue(), ep.getName() + " Image");
		// TODO: need to detect CANCEL?
		ep.setValue(f);
		changed = true;
	}

	private void cardPlug(CardSlot cs) {
		AddOnCard c;
		c = cs.getValue();
		String dev = "none";
		if (c != null) {
			c.configure(frame);
			return;
		}
		// Slot is currently empty...
		if (cs.getType() == cs.MEMORY) {
			selector.setMemSelection(c == null ? "none" : c.getCardName());
			if (!selector.doMemDialog(frame, cs.getName())) {
				return;
			}
			dev = selector.getMemSelection();
		} else {
			selector.setDevSelection(c == null ? "none" : c.getCardName());
			if (!selector.doDevDialog(frame, cs.getName())) {
				return;
			}
			dev = selector.getDevSelection();
		}
		changed = true;
		c = getCard(dev);
		cs.setValue(c);
		// TODO: avoid changing properties here?
		// wait for updateProperties?
		if (c != null) {
			// Could there be any lingering properties?
			c.setProperties(props);
			props.setProperty(cs.getPropertyName(), c.getCardName());
		}
		// Now start configurator...
		c.configure(frame);
	}

	private void z19Plug() {
		z19.configure(frame);
	}

	private void configV89() {
		// h89_nameplate
		// h89_log
		// h89_disas
		V89Dialog dlg = new V89Dialog(props);
		if (!dlg.doDialog(frame, "Config Core V89")) {
			return;
		}
		changed = true;
		// TODO: should this be delayed?
		dlg.updateProperties(props);
	}

	private void configCPNET() {
		// cpnetdevice_port
		// cpnetdevice_clientid
		// cpnetdevice_server##... a la 77422
		CPNETDialog dlg = new CPNETDialog(props);
		if (!dlg.doDialog(frame, "Config CPNETDevice")) {
			return;
		}
		changed = true;
		// TODO: should this be delayed?
		dlg.updateProperties(props);
	}

	private void menuClick(JMenuItem mi) {
		if (mi.getMnemonic() == KeyEvent.VK_N) {
			if (!confirmChanges("New File")) {
				return;
			}
			curFile = null;
			setProperties(new Properties());
			changed = false;
		} else if (mi.getMnemonic() == KeyEvent.VK_O) {
			if (!confirmChanges("Open File")) {
				return;
			}
			setupFile(pickFile(frame, curFile, "Open File"));
		} else if (mi.getMnemonic() == KeyEvent.VK_S) {
			saveFile(false);
		} else if (mi.getMnemonic() == KeyEvent.VK_A) {
			saveFile(true);
		} else if (mi.getMnemonic() == KeyEvent.VK_Q) {
			if (!confirmChanges("Quit")) {
				return;
			}
			System.exit(0);
		} else if (mi.getMnemonic() == KeyEvent.VK_V) {
			configV89();
		} else if (mi.getMnemonic() == KeyEvent.VK_C) {
			configCPNET();
		// HostFileBdos? part of 77422 (FT245R, CPNET)?
			// hostfilebdos##_lst#
			// hostfilebdos##_root_dir ?
			// hostfilebdos##_temp ? (new)
		// Diablo630 ?
			// diablo630_cpi
			// diablo630_lpi
			// diablo630_font
			// diablo630_paper
			// diablo630_nogui ? auto?
			// diablo630_jobend
		// CPNetSocketClient? part of 77422 (FT245R, CPNET)?
			// <prefix>_host
			// <prefix>_port
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() instanceof CardSlot) {
			cardPlug((CardSlot)e.getSource());
		} else if (e.getSource() instanceof EPROM) {
			epromPlug((EPROM)e.getSource());
		} else if (e.getSource() == p513) {
			z19Plug();
		} else if (e.getSource() instanceof JMenuItem) {
			menuClick((JMenuItem)e.getSource());
		} else {
			System.err.format("Unknown action event %s\n", e.getSource().getClass().getName());
		}
	}

	static public void info(Component top, String op, String err) {
		JOptionPane.showMessageDialog(top,
			new JLabel(err),
			op, JOptionPane.INFORMATION_MESSAGE);
	}

	static public void error(Component top, String op, String err) {
		JOptionPane.showMessageDialog(top,
			new JLabel(err),
			op + " Error", JOptionPane.ERROR_MESSAGE);
	}

	static public int confirm(Component top, String op, String err) {
		int res = JOptionPane.showConfirmDialog(top,
			new JLabel(err),
			op + " Confirmation", JOptionPane.YES_NO_OPTION);
		return res;
	}

	public void cardRemoved(AddOnCard cd) {
		for (CardSlot cs : slots) {
			if (cs.getValue() == cd) {
				removeCard(cs);
				return;
			}
		}
	}

	public void propertyChanged() {
		changed = true;
	}

	public static void main(String[] args) {
		thus = new ConfigH89(args);
	}
}
