// Copyright (c) 2017 Douglas Miller <durgadas311@gmail.com>
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

public class Dipsw8 extends JLabel implements Dipsw, ActionListener {
	private ImageIcon on;
	private ImageIcon off;
	private JButton[] btns = new JButton[8];
	private int value = 0;
	private ChangeListener lstn;

	public Dipsw8(String label, ChangeListener lstn, boolean rev,
			ImageIcon bg, ImageIcon on, ImageIcon off) {
		super();
		this.lstn = lstn;
		this.on = on;
		this.off = off;
		setIcon(bg);
		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints gc = new GridBagConstraints();
		setLayout(gb);
		setToolTipText(label);
		gc.fill = GridBagConstraints.NONE;
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0;
		gc.weighty = 0;
		gc.gridwidth = 1;
		gc.gridheight = 1;
		gc.anchor = GridBagConstraints.CENTER;

		ImageObserver io = off.getImageObserver();
		Image im = off.getImage();
		int h = im.getHeight(io);
		int w = im.getWidth(io);
		int h2, w2;
		int dx = 0;
		int dy = 1;
		if (w > h) {
			// Must be stacked vertically, each oriented horizontally...
			h = 3;
			w = 24;
			h2 = 6;
			w2 = 24;
		} else {
			w = 3;
			h = 24;
			w2 = 6;
			h2 = 24;
			dx = 1;
			dy = 0;
		}

		JPanel pn = new JPanel();
		pn.setPreferredSize(new Dimension(w, h));
		for (int x = 0; x < 8; ++x) {
			int xx = x;
			if (rev) {
				xx = 7 - x;
			}
			pn.setOpaque(false);
			gb.setConstraints(pn, gc);
			add(pn);
			gc.gridy += dy;
			gc.gridx += dx;
			btns[xx] = new JButton();
			btns[xx].addActionListener(this);
			btns[xx].setBorder(null);
			btns[xx].setToolTipText(String.format("%s.%d", label, xx));
			gb.setConstraints(btns[xx], gc);
			add(btns[xx]);
			gc.gridy += dy;
			gc.gridx += dx;
			pn = new JPanel();
			pn.setPreferredSize(new Dimension(w2, h2));
		}
		pn.setPreferredSize(new Dimension(w, h));
		pn.setOpaque(false);
		gb.setConstraints(pn, gc);
		add(pn);
		setValue(0);
	}

	public void setValue(int val) {
		value = val;
		for (int x = 0; x < 8; ++x) {
			if ((value & (1 << x)) == 0) {
				btns[x].setIcon(off);
			} else {
				btns[x].setIcon(on);
			}
		}
		if (lstn != null) {
			lstn.propertyChanged();
		}
		repaint();
	}

	public int getValue() {
		return value;
	}

	public String getProp() {
		String s = Integer.toBinaryString(value);
		while (s.length() < 8) {
			s = '0' + s;
		}
		return s;
	}

	public void actionPerformed(ActionEvent e) {
		int v = value;
		for (int x = 0; x < 8; ++x) {
			if (e.getSource() == btns[x]) {
				v ^= (1 << x);
				break;
			}
		}
		setValue(v);
	}
}
