// Copyright (c) 2017 Douglas Miller <durgadas311@gmail.com>
import java.io.*;
import java.util.Vector;

public class DiskImageFile extends File {
	private Vector<String> opts;

	public DiskImageFile(String nm) {
		super(nm);
		opts = new Vector<String>();
	}

	public DiskImageFile(String[] args) {
		super(args[0]);
		opts = new Vector<String>();
		for (int x = 1; x < args.length; ++x) {
			opts.add(args[x]);
		}
	}

	public DiskImageFile(File dup, String[] args) {
		super(dup.getAbsolutePath());
		opts = new Vector<String>();
		for (int x = 0; x < args.length; ++x) {
			opts.add(args[x]);
		}
	}

	public String getProp() {
		String ret = getAbsolutePath();
		for (int x = 0; x < opts.size(); ++x) {
			ret += " " + opts.get(x);
		}
		return ret;
	}

	public String getText() {
		String ret = getName();
		for (int x = 0; x < opts.size(); ++x) {
			ret += " " + opts.get(x);
		}
		return ret;
	}

	public String[] getOpts() {
		return opts.toArray(new String[0]);
	}

	public int getOpt(String op) {
		for (int x = 0; x < opts.size(); ++x) {
			if (opts.get(x).equalsIgnoreCase(op)) {
				return x;
			}
		}
		return -1;
	}

	public void setOpt(String op) {
		if (getOpt(op) >= 0) {
			return;
		}
		opts.add(op);
	}

	public void delOpt(String op) {
		int x = getOpt(op);
		if (x < 0) {
			return;
		}
		opts.remove(x);
	}
}
