// Copyright (c) 2017 Douglas Miller <durgadas311@gmail.com>
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class IDC extends JButton {
	private ImageIcon plug;
	private ImageIcon cable;
	private int value = 0;	// number of drives connected
	private String label = null;
	private String prop = null;

	public IDC(String label, String prop, ImageIcon plug, ImageIcon cable) {
		super();
		this.label = label;
		this.prop = prop;
		this.plug = plug;
		this.cable = cable;
		setBorder(null);
		setOpaque(false);
		setContentAreaFilled(false);
		setBorderPainted(false);
		setToolTipText(label);
		setValue(0);
	}

	public void setValue(int val) {
		value = val;
		if (value == 0) {
			setIcon(plug);
		} else {
			setIcon(cable);
		}
		repaint();
	}

	public int getValue() {
		return value;
	}

	public String getName() {
		return label;
	}

	public String getPropertyName() {
		return prop;
	}
}
