// Copyright (c) 2017 Douglas Miller <durgadas311@gmail.com>
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

// Simple case of a single, 3-pin, 2-position, jumper plug.
// Does not support "no jumper" value.
// Orientation determined by implementing class(es).

public class Jumper3x1 extends JButton implements Jumper, ActionListener {
	private ImageIcon one;
	private ImageIcon zero;
	private int value = 0;
	private ChangeListener lstn;

	public Jumper3x1(String label, ChangeListener lstn, ImageIcon z, ImageIcon o) {
		super();
		this.lstn = lstn;
		zero = z;
		one = o;
		addActionListener(this);
		setBorder(null);
		setToolTipText(label);
		setBackground(AddOnCard.PCB);
		setValue(0);
	}

	public void setValue(int val) {
		value = val;
		if (value == 0) {
			setIcon(zero);
		} else {
			setIcon(one);
		}
		repaint();
	}

	public int getValue() {
		return value;
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == this) {
			setValue(value ^ 1);
			// System.err.format("value = %02x\n", value);
			if (lstn != null) {
				lstn.propertyChanged();
			}
			return;
		}
	}
}
