// Copyright (c) 2017 Douglas Miller <durgadas311@gmail.com>
import java.util.Map;
import java.util.HashMap;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import java.util.Properties;

public class Z19 extends AddOnCard
		implements ChangeListener, WindowListener, ActionListener {

	private Dipsw8 s401;
	private Dipsw8 s402;
	private EPROM u473;
	private JButton beep;
	private JButton p404;
	private String fontname;
	private String fontsize;
	private String fontcolor;
	private String beepname;
	private String beepvol;

	private ChangeListener lstn;

	public Z19(ChangeListener lstn) {
		super("Configure Z19");
		this.lstn = lstn;

		// do not use AddOnCard.layoutCard(),
		// but we can use AddOnCard.place().
		getContentPane().setBackground(AddOnCard.PCB);
		init(this);

		addWindowListener(this);

		////////////////////////////////////////////////
		// Layout Z19 PCB...
		//
		JPanel pn;
		JPanel pn2;
		JPanel pn3;
		ImageIcon le;

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(10,300));
		pn.setOpaque(false);
		place(pn, 0, 0, 1, 6);
		gc.gridheight = 1;

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(300,30));
		pn.setOpaque(false);
		pn.add(new JLabel("Z19 Terminal"));
		place(pn, 1, 0, 4, 1);

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(10,10));
		pn.setOpaque(false);
		place(pn, 5, 0, 1, 1);
		// top row, sides, done

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(100,20));
		pn.setOpaque(false);
		place(pn, 1, 1, 2, 1);

		s402 = new Dipsw180("S402", this);
		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(s402);
		pn.add(new JLabel("S402"));
		pn2 = new JPanel();
		pn2.setOpaque(false);
		pn2.setLayout(new BoxLayout(pn2, BoxLayout.Y_AXIS));
		pn2.add(new JLabel("OFF"));
		pn2.add(new JLabel(" "));
		pn2.add(new JLabel("ON"));
		pn2.add(new JLabel(" "));
		pn3 = new JPanel();
		pn3.setOpaque(false);
		pn3.setLayout(new BoxLayout(pn3, BoxLayout.X_AXIS));
		pn3.add(pn2);
		pn3.add(pn);
		place(pn3, 3, 1, 1, 1);

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(40,50));
		pn.setOpaque(false);
		place(pn, 4, 1, 1, 1);

		++gc.gridy;
		gc.gridx = 1;

		EPROM ep = new EPROM("U473", "FONT (Char Gen)", "h19_font");
		ep.addActionListener(this);
		u473 = ep;
		place(ep, 1, 2, 1, 1);

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(100,20));
		pn.setOpaque(false);
		place(pn, 2, 2, 3, 1);

		le = new ImageIcon(Z19.class.getResource("icons/jp15_ra_ri_cable.png"));
		p404 = new JButton();
		p404.addActionListener(this);
		p404.setBorder(null);
		p404.setBackground(AddOnCard.PCB);
		p404.setIcon(le);
		p404.setToolTipText("Z89");
		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(new JLabel("P404"));
		pn.add(p404);
		place(pn, 5, 2, 1, 1);

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(100,20));
		pn.setOpaque(false);
		place(pn, 1, 3, 3, 1);

		s401 = new Dipsw180("S401", this);
		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(s401);
		pn.add(new JLabel("S401"));
		pn2 = new JPanel();
		pn2.setOpaque(false);
		pn2.setLayout(new BoxLayout(pn2, BoxLayout.Y_AXIS));
		pn2.add(new JLabel("OFF"));
		pn2.add(new JLabel(" "));
		pn2.add(new JLabel("ON"));
		pn2.add(new JLabel(" "));
		pn3 = new JPanel();
		pn3.setOpaque(false);
		pn3.setLayout(new BoxLayout(pn3, BoxLayout.X_AXIS));
		pn3.add(pn2);
		pn3.add(pn);
		place(pn3, 4, 3, 1, 1);

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(10,100));
		pn.setOpaque(false);
		place(pn, 5, 3, 1, 4);

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(10,30));
		pn.setOpaque(false);
		place(pn, 1, 4, 1, 1);

		le = new ImageIcon(Z19.class.getResource("icons/speaker.png"));
		beep = new JButton();
		beep.addActionListener(this);
		beep.setBorder(null);
		beep.setBackground(AddOnCard.PCB);
		beep.setIcon(le);
		beep.setToolTipText("BEEP (Ctrl-G BEL)");
		place(beep, 2, 4, 1, 1);

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(10,10));
		pn.setOpaque(false);
		place(pn, 3, 4, 2, 1);

		pn = new JPanel();
		pn.setPreferredSize(new Dimension(300,50));
		pn.setOpaque(false);
		place(pn, 1, 5, 4, 1);

		pack();
	}

	public void setProperties(Properties props) {
		String s = props.getProperty("h19_s401");
		int v = 0;
		if (s != null) {
			v = Integer.valueOf(s, 2) & 0xff;
		}
		s401.setValue(v);
		s = props.getProperty("h19_s402");
		v = 0;
		if (s != null) {
			v = Integer.valueOf(s, 2) & 0xff;
		}
		s402.setValue(v);
		fontname = props.getProperty("h19_font");
		fontsize = props.getProperty("h19_font_size");
		fontcolor = props.getProperty("h19_font_color");
		beepname = props.getProperty("h19_beep");
		beepvol = props.getProperty("h19_beep_volume");
	}

	public void updateProperties(Properties props) {
		props.setProperty("h19_s401", s401.getProp());
		props.setProperty("h19_s402", s402.getProp());
		if (fontname != null && !fontname.isEmpty()) {
			props.setProperty("h19_font", fontname);
		} else {
			props.remove("h19_font");
		}
		if (fontsize != null && !fontsize.isEmpty()) {
			props.setProperty("h19_font_size", fontsize);
		} else {
			props.remove("h19_font_size");
		}
		if (fontcolor != null && !fontcolor.isEmpty()) {
			props.setProperty("h19_font_color", fontcolor);
		} else {
			props.remove("h19_font_color");
		}
		if (beepname != null && !beepname.isEmpty()) {
			props.setProperty("h19_beep", beepname);
		} else {
			props.remove("h19_beep");
		}
		if (beepvol != null && !beepvol.isEmpty()) {
			props.setProperty("h19_beep_volume", beepvol);
		} else {
			props.remove("h19_beep_volume");
		}
	}

	public void removeProperties(Properties props) {
		// can't ever remove the Z19?
	}

	public String getCardName() { return "Z19"; }

	public boolean configure(Component top) {
		setVisible(true);
		return true;
	}

	public void windowActivated(WindowEvent e) { }
	public void windowClosed(WindowEvent e) { }
	public void windowIconified(WindowEvent e) { }
	public void windowOpened(WindowEvent e) { }
	public void windowDeiconified(WindowEvent e) { }
	public void windowDeactivated(WindowEvent e) { }
	public void windowClosing(WindowEvent e) {
		setVisible(false);
	}

	private void epromPlug(EPROM ep) {
		FontDialog fd = new FontDialog(new String[]{"H19a.ttf"},
			fontname, fontsize, fontcolor);
		if (!fd.doDialog(this, "Z19 Character Generator")) {
			return;
		}
		fontname = fd.getFontName();
		fontsize = fd.getFontSize();
		fontcolor = fd.getFontColor();
		propertyChanged();
	}

	private void beepPlug(JButton ep) {
		String[] beeps = new String[]{
			"h19beep.wav",
			"h19beep250.wav",
			"h19beep125.wav",
		};
		BeepDialog bd = new BeepDialog(beeps, beepname, beepvol);
		if (!bd.doDialog(this, "Z19 Beep")) {
			return;
		}
		beepname = bd.getBeepName();
		beepvol = bd.getBeepVolume();
		propertyChanged();
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() instanceof EPROM) {
			epromPlug((EPROM)e.getSource());
		} else if (e.getSource() == p404) {
			setVisible(false);
		} else if (e.getSource() == beep) {
			beepPlug((JButton)beep);
		} else {
			System.err.format("Unknown action event %s\n", e.getSource().getClass().getName());
		}
	}

	public void cardRemoved(AddOnCard cd) {} // never called from widgets

	public void propertyChanged() {
		// TODO: what else?
		if (lstn != null) {
			lstn.propertyChanged();
		}
	}
}
