// Copyright (c) 2017 Douglas Miller <durgadas311@gmail.com>
import java.util.Map;
import java.util.HashMap;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import java.util.Properties;

public class Z_89_11 extends AddOnCard
		implements ChangeListener, WindowListener, ActionListener {

	private SerialPorts sports;

	private ChangeListener lstn;

	public Z_89_11(ChangeListener lstn) {
		super("Configure Z-89-11");
		this.lstn = lstn;
		sports = new SerialPorts("P603", "P604", "P605", this, this);

		addWindowListener(this);

		layoutCard();
		connectorListener(this);

		////////////////////////////////////////////////
		// Setup menus
		//
		JMenuBar mb = new JMenuBar();
		JMenu mu;
		JMenuItem mi;
		mu = new JMenu("Card");
		mi = new JMenuItem("Remove", KeyEvent.VK_R);
		mi.addActionListener(this);
		mu.add(mi);
		mi = new JMenuItem("Done", KeyEvent.VK_D);
		mi.addActionListener(this);
		mu.add(mi);
		// TODO: can we cancel (cleanly) here?
		mb.add(mu);
		setJMenuBar(mb);

		////////////////////////////////////////////////
		// Layout Z-89-11 PCB...
		//
		JPanel pn;
		JPanel pn2;

		gc.anchor = GridBagConstraints.NORTHEAST;
		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(sports.lpCon);
		pn.add(new JLabel("PRINTER"));
		place(pn, 1, 0, 2, 1);

		gc.anchor = GridBagConstraints.NORTH;
		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(sports.auxCon);
		pn.add(new JLabel("AUX"));
		place(pn, 3, 0, 2, 1);

		gc.anchor = GridBagConstraints.NORTHWEST;
		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(sports.modemCon);
		pn.add(new JLabel("MODEM"));
		place(pn, 5, 0, 1, 1);

		gc.anchor = GridBagConstraints.NORTH;
		pn = new JPanel();
		pn.setPreferredSize(new Dimension(500,300));
		pn.setOpaque(false);
		pn.add(new JLabel("Z-89-11 Serial Ports"));
		place(pn, 1, 1, 5, 1);

		gc.anchor = GridBagConstraints.SOUTH;
		pn2 = new JPanel();
		pn2.setLayout(new BoxLayout(pn2, BoxLayout.X_AXIS));
		pn2.setOpaque(false);

		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(new JLabel("LP"));
		pn.add(sports.lpJp);
		pn2.add(pn);

		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(new JLabel("AUX"));
		pn.add(sports.auxJp);
		pn2.add(pn);

		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(new JLabel("MDM"));
		pn.add(sports.modemJp);
		pn2.add(pn);

		pn = new JPanel();
		pn.setLayout(new BoxLayout(pn, BoxLayout.Y_AXIS));
		pn.setOpaque(false);
		pn.add(new JLabel(" "));
		pn.add(new JLabel("INT3"));
		pn.add(new JLabel("INT4"));
		pn.add(new JLabel("INT5"));
		pn2.add(pn);

		place(pn2, 3, 2, 2, 1);

		finish();
	}

	public void setProperties(Properties props) {
		sports.setProperties(props);
	}

	public void updateProperties(Properties props) {
		sports.updateProperties(props);
	}

	public void removeProperties(Properties props) {
		sports.removeProperties(props);
	}

	public String getCardName() { return "Z-89-11"; }

	public boolean configure(Component top) {
		setVisible(true);
		return true;
	}

	public void windowActivated(WindowEvent e) { }
	public void windowClosed(WindowEvent e) { }
	public void windowIconified(WindowEvent e) { }
	public void windowOpened(WindowEvent e) { }
	public void windowDeiconified(WindowEvent e) { }
	public void windowDeactivated(WindowEvent e) { }
	public void windowClosing(WindowEvent e) {
		setVisible(false);
	}

	private void menuClick(JMenuItem mi) {
		if (mi.getMnemonic() == KeyEvent.VK_R) {
			setVisible(false);
			if (lstn != null) {
				lstn.cardRemoved(this);
			}
		} else if (mi.getMnemonic() == KeyEvent.VK_D) {
			setVisible(false);
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() instanceof JMenuItem) {
			menuClick((JMenuItem)e.getSource());
		} else if (connectorPerformed(e)) {
			setVisible(false);
		} else {
			System.err.format("Unknown action event %s\n", e.getSource().getClass().getName());
		}
	}

	public void cardRemoved(AddOnCard cd) {} // never called from widgets

	public void propertyChanged() {
		// TODO: what else?
		if (lstn != null) {
			lstn.propertyChanged();
		}
	}
}
